/**
 * 最初の著者:: トゥイー
 * リポジトリ情報:: $Id: UnificatedElements.hpp 11 2011-05-14 02:11:18Z yutaka_at_home $
 * 著作権:: Copyright (C) Ownway.info, 2011. All rights reserved.
 * ライセンス:: CPL(Common Public Licence)
 */

#ifndef _TOPS_UNIFICATED_ELEMENTS_
#define _TOPS_UNIFICATED_ELEMENTS_

#include "tops/common/Printable.hpp"

#include <deque>

#include <boost/shared_ptr.hpp>

namespace tops {

	class Contradiction;

	class UnificatedElement;
	typedef boost::shared_ptr<UnificatedElement> UnificatedElementPtr;
	class UnificatedElements;
	typedef boost::shared_ptr<UnificatedElements> UnificatedElementsPtr;

	/**
	 * 単一化済み要素列です。
	 *
	 * @author トゥイー
	 */
	class UnificatedElements : public Printable {
	private:
		typedef std::deque<UnificatedElementPtr> ElementContainer;
		typedef ElementContainer::iterator iterator;
		typedef ElementContainer::const_iterator const_iterator;

		ElementContainer m_elements;

	public:
		/**
		 * サイズを取得します。
		 */
		size_t size() const {
			return m_elements.size();
		}

		/**
		 * ワーキングメモリ要素を取得します。
		 */
		UnificatedElementPtr& operator[](size_t i) {
			return m_elements[i];
		}

		/**
		 * ワーキングメモリ要素を取得します。
		 */
		const UnificatedElementPtr& operator[](size_t i) const {
			return m_elements[i];
		}

		/**
		 * 末尾のワーキングメモリ要素を取得します。
		 */
		const UnificatedElementPtr& back() const {
			return m_elements.back();
		}

		/**
		 * 末尾にワーキングメモリ要素を追加します。
		 */
		void push(const UnificatedElementPtr& element) {
			m_elements.push_back(element);
		}

		/**
		 * 末尾からワーキングメモリ要素を削除します。
		 */
		void pop() {
			m_elements.pop_back();
		}

	public:
		/**
		 * ストリームに出力します。
		 */
		void print(std::ostream& stream) const;
	};

}  // namespace tops

#endif
